/***************************************************************************
 *  Copyright 2007, 2008 Marcelo Y. Matuda                                 *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/

#ifndef ARTICULATION_CONTROLLER_UTIL_H_
#define ARTICULATION_CONTROLLER_UTIL_H_

#include "main.h"

#include <iostream>



namespace Cgstmad {
namespace ArticulationControllerUtil {

/*******************************************************************************
 *
 */
inline
bool
validatePointTime(float time, float beginTime, float endTime, float lastTime)
{
	const float epsilon = 1.0e-6f;

	if (time < beginTime - epsilon) {
		std::cerr << "Warning: time < beginTime time=" << time << " beginTime=" << beginTime << std::endl;
		return false;
	} else if (time > endTime + epsilon) {
		std::cerr << "Warning: time > endTime time=" << time << " endTime=" << endTime << std::endl;
		return false;
	} else if (time < lastTime + epsilon) {
		std::cerr << "Warning: time <= lastTime time=" << time << " lastTime=" << lastTime << std::endl;
		return false;
	} else {
		return true;
	}
}

} /* namespace ArticulationControllerUtil */
} /* namespace Cgstmad */

#endif /* ARTICULATION_CONTROLLER_UTIL_H_ */
