/***************************************************************************
 *  Copyright 2007 Marcelo Y. Matuda                                       *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/

#include "category.h"

#include "controller_exception.h"



namespace Cgstmad {

int
Category::getCode(const CategoryCodeMap& categoryCodeMap, std::string name)
{
	CategoryCodeMap::const_iterator iter = categoryCodeMap.find(name);
	if (iter == categoryCodeMap.end()) {
		throw ControllerException(ControllerError("Category not found: ") << name);
	}
	return iter->second;
}

} /* namespace Cgstmad */
