/***************************************************************************
 *  Copyright 1991, 1992, 1993, 1994, 1995, 1996, 2001, 2002, 2004, 2007   *
 *    David R. Hill, Leonard Manzara, Craig Schock,                        *
 *    Steve Nygard                                                         *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
/***************************************************************************
 * 2007-12-21  mym                                                         *
 *   This code is a translated (from C to C++) and modified version of a   *
 *   GnuSpeech's source code.                                              *
 *                                                                         *
 ***************************************************************************/

#ifndef CONTROL_PARAMETERS_H_
#define CONTROL_PARAMETERS_H_

#include "main.h"

#include "tube_model_constants.h"



namespace Cgstmad {

/*******************************************************************************
 *
 */
struct ControlParameters {
	float glotPitch;
	float glotVol;
	float aspVol;
	float fricVol;
	float fricPos;
	float fricCF;
	float fricBW;
	float radius[TRM_TOTAL_REGIONS];
	float velum;

	ControlParameters()
			: glotPitch(0.0)
			, glotVol(0.0)
			, aspVol(0.0)
			, fricVol(0.0)
			, fricPos(0.0)
			, fricCF(0.0)
			, fricBW(0.0)
			, velum(0.0)
	{
		for (int i = 0; i < TRM_TOTAL_REGIONS; ++i) radius[i] = 0.0;
	}
};

} // namespace Cgstmad

#endif /* CONTROL_PARAMETERS_H_ */
