/***************************************************************************
 *  Copyright 2007, 2008 Marcelo Y. Matuda                                 *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/

#include "formula_symbol.h"

#include <iostream>



namespace Cgstmad {

/*******************************************************************************
 * Constructor.
 */
FormulaSymbol::FormulaSymbol() : codeMap() {
	if (Main::verbose()) std::cout << "Initializing formula symbol map..." << std::endl;

	codeMap["transition1"] = SYMB_TRANSITION1;
	codeMap["transition2"] = SYMB_TRANSITION2;
	codeMap["transition3"] = SYMB_TRANSITION3;
	codeMap["transition4"] = SYMB_TRANSITION4;
	codeMap["qssa1"]       = SYMB_QSSA1;
	codeMap["qssa2"]       = SYMB_QSSA2;
	codeMap["qssa3"]       = SYMB_QSSA3;
	codeMap["qssa4"]       = SYMB_QSSA4;
	codeMap["qssb1"]       = SYMB_QSSB1;
	codeMap["qssb2"]       = SYMB_QSSB2;
	codeMap["qssb3"]       = SYMB_QSSB3;
	codeMap["qssb4"]       = SYMB_QSSB4;
	codeMap["tempo12"]     = SYMB_TEMPO12;
	codeMap["tempo23"]     = SYMB_TEMPO23;
	codeMap["tempo34"]     = SYMB_TEMPO34;
	codeMap["rd"]          = SYMB_RD;
	codeMap["mark1"]       = SYMB_MARK1;
	codeMap["mark2"]       = SYMB_MARK2;
	codeMap["null"]        = SYMB_NULL;
}

} /* namespace Cgstmad */
