/***************************************************************************
 *  Copyright 2007, 2008 Marcelo Y. Matuda                                 *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/

#include "parameters_logger.h"

#include <iostream>

#include "control_parameters.h"
#include "util.h"



namespace Cgstmad {

/*******************************************************************************
 *
 */
void
ParametersLogger::logMarker(int n, const std::string& posture)
{
	// 0 start of posture 1 steady state period
	// 1 start of transition 1 (posture 1 -> posture 2)
	// 2 start of transition 2 (posture 2 -> posture 3)
	// 3 start of transition 3 (posture 3 -> posture 4)
	outFile_ << "MARKER " << n << ' ' << posture << std::endl;
}

/*******************************************************************************
 *
 */
void
ParametersLogger::logParam(const ControlParameters& param)
{
	outFile_
		<< param.glotPitch << ' '
		<< param.glotVol   << ' '
		<< param.aspVol    << ' '
		<< param.fricVol   << ' '
		<< param.fricPos   << ' '
		<< param.fricCF    << ' '
		<< param.fricBW    << ' '
		<< param.radius[0] << ' '
		<< param.radius[1] << ' '
		<< param.radius[2] << ' '
		<< param.radius[3] << ' '
		<< param.radius[4] << ' '
		<< param.radius[5] << ' '
		<< param.radius[6] << ' '
		<< param.radius[7] << ' '
		<< param.velum     << std::endl;
}

} /* namespace Cgstmad */
