/***************************************************************************
 *  Copyright 2007, 2008 Marcelo Y. Matuda                                 *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/

#ifndef PARAMETERS_LOGGER_H_
#define PARAMETERS_LOGGER_H_

#include "main.h"

#include <fstream>
#include <string>



namespace Cgstmad {

struct ControlParameters;

/*******************************************************************************
 *
 */
class ParametersLogger {
public:
	ParametersLogger(const char* filePath) : outFile_(filePath) {}

	void logMarker(int n, const std::string& posture);
	void logParam(const ControlParameters& param);
private:
	std::ofstream outFile_;
};

} /* namespace Cgstmad */

#endif /* PARAMETERS_LOGGER_H_ */
