/***************************************************************************
 *  Copyright 2007 Marcelo Y. Matuda                                       *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/

#ifndef PHONEME_REWRITER_H_
#define PHONEME_REWRITER_H_

#include "main.h"

#include <string>

#include "input_file.h"
#include "simple_config_file.h"



namespace Cgstmad {

class PhonemeRewriter {
public:
	PhonemeRewriter(const std::string& filePath);

	void rewrite(InputFile::InputCommandList& cmdList) const;
private:
	SimpleConfigFile translationFile_;

	void translate(std::string& s) const;
};

inline void
PhonemeRewriter::translate(std::string& s) const
{
	translationFile_.readInto(s, s, false);
}

} /* namespace Cgstmad */

#endif /*PHONEME_REWRITER_H_*/
