/***************************************************************************
 *  Copyright 2007, 2008 Marcelo Y. Matuda                                 *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/

#ifndef PITCH_PROCESSOR_H_
#define PITCH_PROCESSOR_H_

#include "main.h"

#include <vector>



namespace Cgstmad {

/*******************************************************************************
 *
 */
class PitchProcessor {
public:
	struct PitchPeriod {
		float baseTime;
		float basePitch;
		float targetTime;
		float targetPitch;
		float deltaPitch;
	};
	typedef std::vector<PitchPeriod> PitchPeriodList;

	PitchProcessor(float controlRate);

	void reset();
	void addTarget(float targetTime, float targetPitch);
	void addFinalTarget(float targetTime, float targetPitch);
	float getNext();
private:
	bool firstPoint_;
	int position_;
	float timeStep_;
	float previousPitch_;
	PitchPeriodList periodList_;
	PitchPeriodList::size_type currentPeriod_;
};

} /* namespace Cgstmad */

#endif /* PITCH_PROCESSOR_H_ */
