/***************************************************************************
 *  Copyright 2007 Marcelo Y. Matuda                                       *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/

#include "posture.h"

#include "controller_exception.h"



namespace Cgstmad {

/*******************************************************************************
 * Constructor.
 */
Posture::Posture()
{
	parameters_.assign(0.0);
}

/*******************************************************************************
 * Constructor.
 */
Posture::Posture(const std::string& name)
		: name_(name)
{
	parameters_.assign(0.0);
}

/*******************************************************************************
 *
 */
bool
Posture::isMemberOfCategory(int code) const
{
	for (CategoryList::size_type size = categoryList_.size(), i = 0; i < size; ++i) {
		if (categoryList_[i].code == code) return true;
	}
	return false;
}

/*******************************************************************************
 * If postureNameOnly = true, considers only the name of the posture.
 */
bool
Posture::isMemberOfCategory(const std::string& categoryName, bool postureNameOnly) const
{
	if (name_ == categoryName) return true;

	if (!postureNameOnly) {
		for (CategoryList::size_type size = categoryList_.size(), i = 0; i < size; ++i) {
			if (categoryList_[i].name == categoryName) return true;
		}
	}

	return false;
}

} /* namespace Cgstmad */
