/***************************************************************************
 *  Copyright 1991, 1992, 1993, 1994, 1995, 1996, 2001, 2002, 2004, 2007   *
 *    David R. Hill, Leonard Manzara, Craig Schock,                        *
 *    Steve Nygard                                                         *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
/***************************************************************************
 * 2007-12-21  mym                                                         *
 *   This code is a translated (from C to C++) and modified version of a   *
 *   GnuSpeech's source code.                                              *
 *                                                                         *
 ***************************************************************************/

#ifndef OUTPUT_FILE_H_
#define OUTPUT_FILE_H_

#include "main.h"

#include <cstdio>
#include <vector>



namespace Cgstmad {

struct ProgramConfiguration;

class OutputFile {
public:
	OutputFile(const std::vector<float>& inputBuffer, float maximumSampleValue, const ProgramConfiguration& inputParameters, const char *fileName);
	~OutputFile();

	void write();
private:
	FILE* fd_;
	const std::vector<float>& inputBuffer_;
	float maximumSampleValue_;
	const ProgramConfiguration& configuration_;

	OutputFile(const OutputFile&);
	OutputFile& operator=(const OutputFile&);
};

} /* namespace Cgstmad */

#endif /*OUTPUT_FILE_H_*/
