/***************************************************************************
 *  Copyright 2009 Marcelo Y. Matuda                                       *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/

#ifndef GLOTTAL_NOISE_ENVELOPE_H_
#define GLOTTAL_NOISE_ENVELOPE_H_

#include "cgstmad_trm.h"



namespace Cgstmad {

/*******************************************************************************
 *
 */
class GlottalNoiseEnvelope {
public:
	GlottalNoiseEnvelope(float firstPulseEndLevel, float secondPulseStartLevel);

	void startOpenPhase();
	float get(float pulse);
private:
	enum Phase {
		PHASE_OFF,
		PHASE_OPEN,
		PHASE_CLOSE
	};

	const float firstPulseEndLevel_;
	const float secondPulseStartLevel_;
	const float firstPulseMiddleLevel_;
	Phase phase_;
	float previousPulseValue_;
	long position_;
	long middlePosition_;
	long stopPosition_;
};

} // namespace Cgstmad

#endif /* GLOTTAL_NOISE_ENVELOPE_H_ */
