/***************************************************************************
 *  Copyright 1991, 1992, 1993, 1994, 1995, 1996, 2001, 2002, 2004, 2007   *
 *    David R. Hill, Leonard Manzara and Craig Schock                      *
 *    Steve Nygard                                                         *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
/***************************************************************************
 * 2007-12-21  mym                                                         *
 *   This code is a translated (from C to C++) and modified version of a   *
 *   GnuSpeech's source code.                                              *
 *                                                                         *
 ***************************************************************************/

#ifndef GLOTTAL_NOISE_FILTER_H_
#define GLOTTAL_NOISE_FILTER_H_

#include "cgstmad_trm.h"



namespace Cgstmad {

/*******************************************************************************
 * One-zero lowpass filter.
 */
template<typename F>
class GlottalNoiseFilter {
public:
	GlottalNoiseFilter();

	F filter(F x);
private:
	F x1_;
};



/*******************************************************************************
 * Constructor.
 */
template<typename F>
GlottalNoiseFilter<F>::GlottalNoiseFilter() : x1_(0.0) {}

/*******************************************************************************
 *
 */
template<typename F>
F
GlottalNoiseFilter<F>::filter(F x) {
	F y = (x + x1_) * 0.5f;
	x1_ = x;
	return y;
}

} // namespace Cgstmad

#endif /*GLOTTAL_NOISE_FILTER_H_*/
