/***************************************************************************
 *  Copyright 2008 Marcelo Y. Matuda                                       *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/

#ifndef MATH_UTIL_H_
#define MATH_UTIL_H_

#include "cgstmad_trm.h"



// Math constants.
#define PI     3.14159265358979323846
#define TWO_PI (2.0 * PI)



namespace Cgstmad {
namespace MathUtil {

/*******************************************************************************
 * Rounds to the nearest integer.
 */
template<typename I, typename F>
I roundToInt(F fpValue) //TODO: Find a better C++ rounding function
{
	//if (fpValue == 0.0f) return 0;
	return static_cast<I>((fpValue >= 0.0f) ? (fpValue + 0.5f) : (fpValue - 0.5f));
}

/*******************************************************************************
 *
 */
template<typename T>
void
bound(T& value, T minimumValue, T maximumValue)
{
	if (value < minimumValue) {
		value = minimumValue;
	} else if (value > maximumValue) {
		value = maximumValue;
	}
}

} /* namespace MathUtil */
} /* namespace Cgstmad */

#endif /*MATH_UTIL_H_*/
