
#include "noise_source.h"



namespace {

const long m = 2147483647L; // 2^31 - 1
const double cx = 1.0 / m;

//const long a =  16807L;
//const long q = 127773L; // m / a
//const long r =   2836L; // m % a

const long a = 48271L;
const long q = 44488L; // m / a
const long r =  3399L; // m % a
// x0       =          1L
// x200000  =  868148613L
// x400000  =  303985330L
// x600000  = 1138358236L
// x800000  =  531340100L
// x1000000 = 1263606197L
// x1200000 = 1860822966L
// x1400000 = 1135987702L
// x1600000 = 1255763798L
// x1800000 = 1168443650L
// x2000000 =   24123260L

//const long a = 69621L;
//const long q = 30845L; // m / a
//const long r = 23902L; // m % a

} /* namespace */

//==============================================================================

namespace Cgstmad {

/*******************************************************************************
 * Constructor.
 */
NoiseSource::NoiseSource(long x0)
		: x_(x0 % m)
{
}

/*******************************************************************************
 * Returns one value of a pseudorandom sequence [-0.5,0.5).
 */
double
NoiseSource::get()
{
	x_ = a * ( x_ % q ) - r * ( x_ / q );
	if (x_ < 0 ) {
		x_ += m;
	}

	return x_ * cx - 0.5;
}

} /* namespace Cgstmad */
