/***************************************************************************
 *  Copyright 1991, 1992, 1993, 1994, 1995, 1996, 2001, 2002, 2004, 2007   *
 *    David R. Hill, Leonard Manzara, Craig Schock,                        *
 *    Steve Nygard                                                         *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
/***************************************************************************
 * 2007-12-21  mym                                                         *
 *   This code is a translated (from C to C++) and modified version of a   *
 *   GnuSpeech's source code.                                              *
 *                                                                         *
 ***************************************************************************/

#include "ring_buffer.h"

#include "sample_rate_converter.h"



namespace Cgstmad {

/*******************************************************************************
 * Constructor.
 */
RingBuffer::RingBuffer(SampleRateConverter& sampleRateConverter)
					: padSize(0)
					, fillSize(0)
					, fillPtr(0)
					, emptyPtr(0)
					, fillCounter(0)
					, sampleRateConverter(sampleRateConverter)
					, buffer()
{
	padSize = sampleRateConverter.padSize_;
	fillSize = BUFFER_SIZE - (2 * padSize);
	fillPtr = padSize;

	buffer.assign(0.0);
}

void
RingBuffer::dataEmpty()
{
	sampleRateConverter.resample();
}

} /* namespace Cgstmad */
